   /*
    * Licensed Material - Property of IBM
    * 
    * (C) Copyright IBM Corp. 2003, 2005  All Rights Reserved.
    * US Government Users Restricted Rights - Use, duplication or disclosure
    * restricted by GSA ADP Schedule Contract with IBM Corp.
    */

/*
CRTBNDC PGM(QPRCAUDIT) OUTPUT(*PRINT) SYSIFCOPT(*IFSIO)

RCVJRNE JRN(QAUDJRN) EXITPGM(QPRCAUDIT) ENTFMT(*JRNENTFMT)
        JRNENTFMT(RJNE0200)
*/
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qjournal.h>
#include <qmhrcvm.h>
#include <qusec.h>
#include <qwccvtdt.h>
Qjo_RJNE0200_Hdr_t *rjne0200Hdr;
char                statusChanges3;
FILE *stream;
Qus_EC_t error_code;
 typedef struct {
   Qmh_Rcvm_RCVM0100_t RCVM0100;
   char message511;
 } messageInfo_struct;
void process(Qjo_RJNE0200_Hdr_t *rjne0200Hdr)
{
 Qjo_RJNE0200_JE_Hdr_t *rjne0200JEHdr;
 Qjo_RJNE0100_JE_ESD_t *ESD_ptr;
 int entry, dataLen;
 char timeStamp20;
 char tempStr14;
 rjne0200JEHdr = (Qjo_RJNE0200_JE_Hdr_t *)((char *)rjne0200Hdr +
                 rjne0200Hdr->Offset_First_Jrn_Entry);
 for (entry = 1;
      entry <= rjne0200Hdr->Number_Entries_Retreived;
      entry++)
      {
		  fprintf(stream,"\n");
		  fprintf(stream,"----------BEGIN RECORD----------");
		  fprintf(stream,"\n");
		  fprintf(stream,"Dsp_Next_Jrn_Hdr:");
		  fprintf(stream,"%05u",rjne0200JEHdr->Dsp_Next_Jrn_Hdr);
		  fprintf(stream,"\n");

		  fprintf(stream,"Seq_Number:");
		  fprintf(stream,"%020llu",rjne0200JEHdr->Seq_Number);
		  fprintf(stream,"\n");

		  fprintf(stream,"Jrn_Code:");
		  fprintf(stream,"%1.1s",rjne0200JEHdr->Jrn_Code);
		  fprintf(stream,"\n");

		  fprintf(stream,"Entry_Type:");
		  fprintf(stream,"%2.2s",rjne0200JEHdr->Entry_Type);
		  fprintf(stream,"\n");

		   QWCCVTDT("*DTS      ",
					&(rjne0200JEHdr->Unformatted_Time_Stamp),
					"*YYMD     ", &timeStamp, &error_code);

		  fprintf(stream,"TimeStamp:");
		  fprintf(stream,"%-17.17s",timeStamp);
		  fprintf(stream,"\n");

		  fprintf(stream,"Job_Name:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->Job_Name);
		  fprintf(stream,"\n");

		  fprintf(stream,"User_Name:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->User_Name);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Job_Number:");
		  fprintf(stream,"%-6.6s",rjne0200JEHdr->Job_Number);
		  fprintf(stream,"\n");

		  fprintf(stream,"Program_Name:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->Program_Name);
		  fprintf(stream,"\n");

		  fprintf(stream,"Program_Library_Name:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->Program_Library_Name);
		  fprintf(stream,"\n");		

		  fprintf(stream,"Program_ASP_Device_Name:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->Program_ASP_Device_Name);
		  fprintf(stream,"\n");

		  fprintf(stream,"Object:");
		  fprintf(stream,"%-30.30s",rjne0200JEHdr->Object);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Count_Rel_Rec_Num:");
		  fprintf(stream,"%020llu",rjne0200JEHdr->Count_Rel_Rec_Num);
		  fprintf(stream,"\n");

		  fprintf(stream,"Indicator_Flag:");
		  fprintf(stream,"%-1.1s",rjne0200JEHdr->Indicator_Flag);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Commit_Cycle_Id:");
		  fprintf(stream,"%020llu",rjne0200JEHdr->Commit_Cycle_Id);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"User_Profile:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->User_Profile);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"System_Name:");
		  fprintf(stream,"%-8.8s",rjne0200JEHdr->System_Name);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Jid:");
		  fprintf(stream,"%-10.10s",rjne0200JEHdr->Jid);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Object_Name_Indicator:");
		  fprintf(stream,"%-1.1s",rjne0200JEHdr->Object_Name_Indicator);
		  fprintf(stream,"\n");

		  fprintf(stream,"System_Sequence_Number:");
		  fprintf(stream,"%020llu",rjne0200JEHdr->System_Sequence_Number);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Thread_ID:");
		  fprintf(stream,"%020llu",rjne0200JEHdr->Thread_ID);
		  fprintf(stream,"\n");

		  fprintf(stream,"Address_Family:");
		  fprintf(stream,"%-1.1s",rjne0200JEHdr->Address_Family);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Remote_Port:");
		  fprintf(stream,"%05llu",rjne0200JEHdr->Remote_Port);
		  fprintf(stream,"\n");
		
		  fprintf(stream,"Remote_Address:");
		  fprintf(stream,"%-16.16s",rjne0200JEHdr->Remote_Address);
		  fprintf(stream,"\n");
		
		   ESD_ptr = (Qjo_RJNE0100_JE_ESD_t *)((char *)rjne0200JEHdr +
					  rjne0200JEHdr -> Dsp_Entry_Specific_Data);
		   dataLen = atoi(ESD_ptr->Len_ESD);

		   if (dataLen > 0)
		   {
				fprintf(stream,"Extended_Data:");
				sprintf(tempStr, "%%-%d.%ds", dataLen, dataLen);
				fprintf(stream, tempStr, &ESD_ptr->ESD);
				fprintf(stream,"\n");
		   }

		   fprintf(stream,"---------END RECORD----------");
		   fprintf(stream,"\n");
		   rjne0200JEHdr =(Qjo_RJNE0200_JE_Hdr_t *)((char *)rjne0200JEHdr +
						   rjne0200JEHdr->Dsp_Next_Jrn_Hdr);
		}
}
int main(int argc, char *argvݨ)
{
 char *pathEnv = "LOGFILE";
 char *pathName;
 char path512;
 messageInfo_struct messageInfo;
 rjne0200Hdr = (Qjo_RJNE0200_Hdr_t *) argv1;
 memcpy(&(statusChanges), argv2, 3);
 error_code.Bytes_Provided = 0;
 /* Get log file path                                          */
 pathName = getenv(pathEnv);
 if (pathName == NULL)
 {
   QMHRCVM(&messageInfo, sizeof(messageInfo_struct), "RCVM0100",
           "QPRCAUDIT QGLACVT      ", "*ANY      ", "    ", 0,
           "*REMOVE   ", &error_code);
   if (messageInfo.RCVM0100.Bytes_Available > 0)
   {
     if (memcmp(messageInfo.message, "LOGFILE=", 8) == 0)
     {
       memset(path, 0, sizeof(path));
       memcpy(path, messageInfo.message,
              messageInfo.RCVM0100.Data_Returned);
       putenv(path);
       pathName = getenv(pathEnv);
     }
     else
     {
       printf("No log path found\n");
       memcpy(argv2,"9",1);
       return 1;
     }
   }
   else
   {
       printf("No message found\n");
       memcpy(argv2,"9",1);
       return 1;
   }
 }
 stream = fopen(pathName, "a");
 if (stream == NULL)
 {
   printf("Error opening <%s>, errno = %d\n", pathName, errno);
   memcpy(argv2,"9",1);
   return 1;
 }
 switch (statusChanges0)
 {
   case '0':  /* No Journal entries       */
     break;
   case '1':  /* Single entry             */
   case '2':  /* Block of entries         */
     process(rjne0200Hdr);
     break;
   case '3':  /* Journal not attached     */
     break;
   case '4':  /* Journal not active       */
     break;
 }
 /* Should we end after processing this buffer?                */
 QMHRCVM(&messageInfo, sizeof(messageInfo_struct), "RCVM0100",
         "QPRCAUDIT QGLACVT      ", "*ANY      ", "    ", 0,
         "*REMOVE   ", &error_code);
 if (messageInfo.RCVM0100.Bytes_Available > 0)
 {
   if (memcmp(messageInfo.message, "*END", 4) == 0)
   {
     memcpy(argv2,"9",1);
     return 0;
   }
 }
 if (statusChanges0 != '2') /* Indicate blocking mode for next call*/
 {
   memcpy(argv1,"10000",5);
   memcpy(argv2,"8",1);
 }
 fclose(stream);
 return 0;
}
