import org.eclipse.core.runtime.Platform;
import org.eclipse.ui.plugin.*;
import org.osgi.framework.BundleContext;
import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class CommonLoggingSamplePlugin extends AbstractUIPlugin {
	
    //Shared instance:
	private static CommonLoggingSamplePlugin plugin = null;
	
	//Resource bundle:
	private ResourceBundle resourceBundle = null;
	
	/**
	 * The constructor.
	 */
	public CommonLoggingSamplePlugin() {
		
	    super();
		
	    plugin = this;
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
	}

	/**
	 * Returns the shared instance.
	 */
	public static CommonLoggingSamplePlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		
	    ResourceBundle bundle = CommonLoggingSamplePlugin.getDefault().getResourceBundle();
		
	    try {
			return (bundle != null) ? bundle.getString(key) : key;
		} 
	    catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
	    
	    if(resourceBundle == null){
	        
	        try {
				resourceBundle = Platform.getResourceBundle(getDefault().getBundle());
			} 
		    catch (MissingResourceException x) {
		        //Ignore since the resource bundle is missing.
			}		    
	    }
	    
		return resourceBundle;
	}
}
